
# NSTA Development (Master)

NSTA auf dem Master System entwicklen und debugging mit VS Code

1. Aktuelle Go Version auf dem Master System installieren

https://github.com/golang/go/wiki/Ubuntu

2. Repository clonen
```
cd /opt/openitc
git clone https://github.com/it-novum/nsta.git
chown nagios:nagios nsta -R
```

3. SSH Keys austauschen für den Nagios Benutzer
```
touch /var/lib/nagios/.ssh/authorized_keys
chmod 644 /var/lib/nagios/.ssh/authorized_keys
```

SSH Key dann nach `/var/lib/nagios/.ssh/authorized_keys` einfügen

3. VS Code per SSH Verbinden

![Step 1](/docs/images/remote_1.png)

![Step 2](/docs/images/remote_2.png)

![Step 3](/docs/images/remote_3.png)

![Step 4](/docs/images/remote_4.png)

![Step 5](/docs/images/remote_5.png)

![Step 6](/docs/images/remote_6.png)

![Step 7](/docs/images/remote_7.png)

4. In VS Code die Go Extension installieren

Die [Go extension](https://marketplace.visualstudio.com/items?itemName=golang.Go) muss einmal per SSH auf dem Zielsystem installiert werden
![Step 1](/docs/images/go_ext_1.png)
Danach auf
![Step 2](/docs/images/go_ext_2.png)
Oder alternativ: `ctrl` + `shift` + `P` (Windows und Linux) oder `cmd` + `shift` + `P` auf macOS und dann `Go: Install/Update Tools`

5. Launch config erstellen

![Step 1](/docs/images/launch_1.png)

Dann `Go` -> `Go: Launch package`:

launch.json (der Default sollte passen)
```js
{
    // Use IntelliSense to learn about possible attributes.
    // Hover to view descriptions of existing attributes.
    // For more information, visit: https://go.microsoft.com/fwlink/?linkid=830387
    "version": "0.2.0",
    "configurations": [
        {
            "name": "Launch Package",
            "type": "go",
            "request": "launch",
            "mode": "debug",
            "program": "${workspaceFolder}"
        }
    ]
}
```

Ab jetzt kann der NSTA über VS Code gestartet werden, auch im Debugger


# NSTA Development (SAT)
Alles gleich wie auf dem Master, allerdings muss man die `/opt/openitc/etc/nsta/nsta.ini` Config erstellt werden:

## Fur Push SAT Systeme

SAT pushed Daten auf Master

```ini
[nsta]
mode=https_push
satellite-id=ADDYOUTSATELLITEIDHERE
api-key=ADDYOURAPIKEYHERE
endpoint=https://HOSTNAMEORIPOFOITC
insecure-https=true
```

## Fur Pull SAT Systeme

Master fragt Daten vom SAT ab

```ini
[nsta]
satellite-id=ADDYOUTSATELLITEIDHERE
api-key=ADDYOURAPIKEYHERE
mode=https_pull
```
